<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Driver StructType
 * @subpackage Structs
 */
class Driver extends AbstractStructBase
{
    /**
     * The dr_Id
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $dr_Id;
    /**
     * The dr_IdFleet
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $dr_IdFleet;
    /**
     * The dr_cedula
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $dr_cedula;
    /**
     * The dr_name
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $dr_name;
    /**
     * The dr_address
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $dr_address;
    /**
     * The dr_phone
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $dr_phone;
    /**
     * The dr_cellphone
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $dr_cellphone;
    /**
     * The dr_email
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $dr_email;
    /**
     * The dr_mId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $dr_mId;
    /**
     * The dr_status
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $dr_status;
    /**
     * The dr_mIdValids
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfString
     */
    public $dr_mIdValids;
    /**
     * Constructor method for Driver
     * @uses Driver::setDr_Id()
     * @uses Driver::setDr_IdFleet()
     * @uses Driver::setDr_cedula()
     * @uses Driver::setDr_name()
     * @uses Driver::setDr_address()
     * @uses Driver::setDr_phone()
     * @uses Driver::setDr_cellphone()
     * @uses Driver::setDr_email()
     * @uses Driver::setDr_mId()
     * @uses Driver::setDr_status()
     * @uses Driver::setDr_mIdValids()
     * @param int $dr_Id
     * @param int $dr_IdFleet
     * @param string $dr_cedula
     * @param string $dr_name
     * @param string $dr_address
     * @param string $dr_phone
     * @param string $dr_cellphone
     * @param string $dr_email
     * @param string $dr_mId
     * @param string $dr_status
     * @param \ArrayType\ArrayOfString $dr_mIdValids
     */
    public function __construct($dr_Id = null, $dr_IdFleet = null, $dr_cedula = null, $dr_name = null, $dr_address = null, $dr_phone = null, $dr_cellphone = null, $dr_email = null, $dr_mId = null, $dr_status = null, \ArrayType\ArrayOfString $dr_mIdValids = null)
    {
        $this
            ->setDr_Id($dr_Id)
            ->setDr_IdFleet($dr_IdFleet)
            ->setDr_cedula($dr_cedula)
            ->setDr_name($dr_name)
            ->setDr_address($dr_address)
            ->setDr_phone($dr_phone)
            ->setDr_cellphone($dr_cellphone)
            ->setDr_email($dr_email)
            ->setDr_mId($dr_mId)
            ->setDr_status($dr_status)
            ->setDr_mIdValids($dr_mIdValids);
    }
    /**
     * Get dr_Id value
     * @return int
     */
    public function getDr_Id()
    {
        return $this->dr_Id;
    }
    /**
     * Set dr_Id value
     * @param int $dr_Id
     * @return \StructType\Driver
     */
    public function setDr_Id($dr_Id = null)
    {
        // validation for constraint: int
        if (!is_null($dr_Id) && !(is_int($dr_Id) || ctype_digit($dr_Id))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($dr_Id, true), gettype($dr_Id)), __LINE__);
        }
        $this->dr_Id = $dr_Id;
        return $this;
    }
    /**
     * Get dr_IdFleet value
     * @return int
     */
    public function getDr_IdFleet()
    {
        return $this->dr_IdFleet;
    }
    /**
     * Set dr_IdFleet value
     * @param int $dr_IdFleet
     * @return \StructType\Driver
     */
    public function setDr_IdFleet($dr_IdFleet = null)
    {
        // validation for constraint: int
        if (!is_null($dr_IdFleet) && !(is_int($dr_IdFleet) || ctype_digit($dr_IdFleet))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($dr_IdFleet, true), gettype($dr_IdFleet)), __LINE__);
        }
        $this->dr_IdFleet = $dr_IdFleet;
        return $this;
    }
    /**
     * Get dr_cedula value
     * @return string|null
     */
    public function getDr_cedula()
    {
        return $this->dr_cedula;
    }
    /**
     * Set dr_cedula value
     * @param string $dr_cedula
     * @return \StructType\Driver
     */
    public function setDr_cedula($dr_cedula = null)
    {
        // validation for constraint: string
        if (!is_null($dr_cedula) && !is_string($dr_cedula)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dr_cedula, true), gettype($dr_cedula)), __LINE__);
        }
        $this->dr_cedula = $dr_cedula;
        return $this;
    }
    /**
     * Get dr_name value
     * @return string|null
     */
    public function getDr_name()
    {
        return $this->dr_name;
    }
    /**
     * Set dr_name value
     * @param string $dr_name
     * @return \StructType\Driver
     */
    public function setDr_name($dr_name = null)
    {
        // validation for constraint: string
        if (!is_null($dr_name) && !is_string($dr_name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dr_name, true), gettype($dr_name)), __LINE__);
        }
        $this->dr_name = $dr_name;
        return $this;
    }
    /**
     * Get dr_address value
     * @return string|null
     */
    public function getDr_address()
    {
        return $this->dr_address;
    }
    /**
     * Set dr_address value
     * @param string $dr_address
     * @return \StructType\Driver
     */
    public function setDr_address($dr_address = null)
    {
        // validation for constraint: string
        if (!is_null($dr_address) && !is_string($dr_address)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dr_address, true), gettype($dr_address)), __LINE__);
        }
        $this->dr_address = $dr_address;
        return $this;
    }
    /**
     * Get dr_phone value
     * @return string|null
     */
    public function getDr_phone()
    {
        return $this->dr_phone;
    }
    /**
     * Set dr_phone value
     * @param string $dr_phone
     * @return \StructType\Driver
     */
    public function setDr_phone($dr_phone = null)
    {
        // validation for constraint: string
        if (!is_null($dr_phone) && !is_string($dr_phone)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dr_phone, true), gettype($dr_phone)), __LINE__);
        }
        $this->dr_phone = $dr_phone;
        return $this;
    }
    /**
     * Get dr_cellphone value
     * @return string|null
     */
    public function getDr_cellphone()
    {
        return $this->dr_cellphone;
    }
    /**
     * Set dr_cellphone value
     * @param string $dr_cellphone
     * @return \StructType\Driver
     */
    public function setDr_cellphone($dr_cellphone = null)
    {
        // validation for constraint: string
        if (!is_null($dr_cellphone) && !is_string($dr_cellphone)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dr_cellphone, true), gettype($dr_cellphone)), __LINE__);
        }
        $this->dr_cellphone = $dr_cellphone;
        return $this;
    }
    /**
     * Get dr_email value
     * @return string|null
     */
    public function getDr_email()
    {
        return $this->dr_email;
    }
    /**
     * Set dr_email value
     * @param string $dr_email
     * @return \StructType\Driver
     */
    public function setDr_email($dr_email = null)
    {
        // validation for constraint: string
        if (!is_null($dr_email) && !is_string($dr_email)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dr_email, true), gettype($dr_email)), __LINE__);
        }
        $this->dr_email = $dr_email;
        return $this;
    }
    /**
     * Get dr_mId value
     * @return string|null
     */
    public function getDr_mId()
    {
        return $this->dr_mId;
    }
    /**
     * Set dr_mId value
     * @param string $dr_mId
     * @return \StructType\Driver
     */
    public function setDr_mId($dr_mId = null)
    {
        // validation for constraint: string
        if (!is_null($dr_mId) && !is_string($dr_mId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dr_mId, true), gettype($dr_mId)), __LINE__);
        }
        $this->dr_mId = $dr_mId;
        return $this;
    }
    /**
     * Get dr_status value
     * @return string|null
     */
    public function getDr_status()
    {
        return $this->dr_status;
    }
    /**
     * Set dr_status value
     * @param string $dr_status
     * @return \StructType\Driver
     */
    public function setDr_status($dr_status = null)
    {
        // validation for constraint: string
        if (!is_null($dr_status) && !is_string($dr_status)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dr_status, true), gettype($dr_status)), __LINE__);
        }
        $this->dr_status = $dr_status;
        return $this;
    }
    /**
     * Get dr_mIdValids value
     * @return \ArrayType\ArrayOfString|null
     */
    public function getDr_mIdValids()
    {
        return $this->dr_mIdValids;
    }
    /**
     * Set dr_mIdValids value
     * @param \ArrayType\ArrayOfString $dr_mIdValids
     * @return \StructType\Driver
     */
    public function setDr_mIdValids(\ArrayType\ArrayOfString $dr_mIdValids = null)
    {
        $this->dr_mIdValids = $dr_mIdValids;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Driver
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
